    Program
!    Include('winequ.clw')
    Map
    Include('csproto.clw','Socket Wrench')
    End
iRetInit    signed
strHostName cString(256)
hClient     long
strBuffer   cString (2048)
strSend     cString (2048)
strReply    cString (2048)
iRetRead    signed
iRetWrite   signed
iRetDisconnect  signed
NullString  cstring('')
    Include('csconst.clw')

EchoWindow WINDOW('SocketWrench Echo Demo'),AT(,,208,159),SYSTEM
       STRING('Host'),AT(64,2,47,10),USE(?lblHost)
       TEXT,AT(60,13,112,15),USE(strHostName),REQ,SINGLE
       STRING('Send'),AT(15,32,41,13),USE(?lblSend)
       TEXT,AT(11,48,57,33),USE(strSend),REQ,SINGLE
       STRING('Reply'),AT(97,31,63,12),USE(?lblReply)
       TEXT,AT(83,44,86,70),USE(strReply),VSCROLL
       BUTTON('&Connect'),AT(27,120,33,20),USE(?cbtnConnect)
       BUTTON('Dis&connect'),AT(66,122,43,20),USE(?cbtnDisconnect),HIDE
       BUTTON('&Send'),AT(122,122,40,20),USE(?cbtnSend),DISABLE
     END

ConnectErrorDialog WINDOW('Connect Error'),AT(,,104,59),SYSTEM
       STRING('Error Connecting to Server.'),AT(6,9),CENTER
       BUTTON('&OK'),AT(27,27,29,20),USE(?ConnErrOK)
     END

WriteErrorDialog    Window('Write Error'), at(,,60,40)
                        String('Error Writing to Server.'),center
                        Button('&OK'), at (40,32,5,20), use(?WriteErrorOK)
                    End

ReadErrorDialog     Window('Read Error'), at(,,60,40)
                        String('Error Reading from Server.'), center
                        Button('&OK'), at (40,32,5,20), use(?ReadErrorOK)
                    End
    Code
    Open(EchoWindow)
    Accept
        Case event()
        Of Event:OpenWindow
            iRetInit=InetInitialize(NullString, 0)
        Of Event:CloseWindow
            InetUninitialize()
        End
        CASE Field()
        Of ?cbtnConnect
            Case Event()
            Of Event:Accepted
                Update(?strHostName)
                !strHostName=?editHostName
                hClient=InetConnect(strHostName, INET_PORT_ECHO, INET_PROTOCOL_TCP, 10)
                If hClient<0
                    !Open(ConnectErrorDialog)
                    Message('Error Connecting to server.')
                    Disable(?cbtnSend)
                else
                    enable(?cbtnSend)
                    unhide(?cbtnDisconnect)
                    hide(?cbtnConnect)
                end
            end
        Of ?cbtnSend
            Case Event()
            Of Event:Accepted
                update(?strSend)
                strBuffer=strSend
                iRetWrite=InetWrite(hClient,strBuffer,len(strBuffer))
                if iRetWrite<0
                    !Open(WriteErrorDialog)
                    Message('Error Writing to server.')
                else
                    strBuffer=''
                    iRetRead=InetRead(hClient, strBuffer, 2048)
                    if iRetRead<0
                        !Open(ReadErrorDialog)
                        Message('Error Reading from server.')
                    else
                        !?editReply{PROP:TEXT}=strBuffer
                        strReply = strBuffer
                        Display
                    end
                end
            end
        Of ?cbtnDisconnect
            Case Event()
            Of Event:Accepted
                iRetDisconnect=InetDisconnect(hClient)
                Hide(?cbtnDisconnect)
                UnHide(?cbtnConnect)
                Disable(?cbtnSend)
                Display
            End
        Of ?strHostName
            Case Event()
            Of Event:AlertKey
                If KeyCode()=13 then update(?strHostName).
                !strHostName=?editHostName
                hClient=InetConnect(strHostName, INET_PORT_ECHO, INET_PROTOCOL_TCP, 60)
                if hClient<0
                    !Open(ConnectErrorDialog)
                    Message('Error Reading from server.')
                    Disable(?cbtnSend)
                    !Accept
                    !if Accepted()=?ConnErrOK then break
                    !end.
                else
                    enable(?cbtnSend) 
                    Disable(?strHostName)
                    Display
                end
            end
        Of ?strSend
            Case Event()
            Of Event:AlertKey
                If KeyCode()=13 then update(?strSend).
                !strBuffer=?editSend
                iRetWrite=InetWrite(hClient,strBuffer,len(strBuffer))
                if iRetWrite<0
                    !Open(WriteErrorDialog)
                    Message('Error Writing to server.')
                    !Accept
                    !If Accepted()=?WriteErrorOK then break
                    !end.
                else
                    strBuffer=''
                    iRetRead=InetRead(hClient,strBuffer,2048)
                    if iRetRead<0
                        !Open(ReadErrorDialog)
                        Message('Error Reading from server.')
                    else
                        !?editReply{PROP:TEXT}=strBuffer
                        strReply=strBuffer
                        Display
                    end
                end
        end
    end
    end








